﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Xml;
using System.IO;
using System.Net;
public partial class OnSaleList : System.Web.UI.Page
{
    taobaoApi myapi = null;
    public DataTable dt = null;
    string sip_sessionid = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["sip_sessionid"] != null)
        {
            sip_sessionid = Session["sip_sessionid"].ToString();
        }
        else
        {
            sip_sessionid = Guid.NewGuid().ToString();
            Session["sip_sessionid"] = sip_sessionid;
        }
        GetItemList();
    }

    /// <summary>
    /// 此接口方法以实现得到当前会话用户（必须为卖家）的出售中商品列表。支持分页
    /// </summary>
    private void GetItemList()
    {

        CreatTable();
        myapi = new taobaoApi();
        HttpWebResponse myReponse = myapi.taobao_items_onsale_get("", "iid,title,nick,type,cid,pic_path,delist_time,price,post_fee", 0, 0, false, false, "", "", "");
        StreamReader reader = new StreamReader(myReponse.GetResponseStream(), System.Text.Encoding.UTF8);
        string content = reader.ReadToEnd();
        string sip_status = myReponse.GetResponseHeader("sip_status");


        XmlDocument xmlDoc = new XmlDocument();
        xmlDoc.LoadXml(content);
        XmlNode url = xmlDoc.SelectSingleNode("//url");
        //根据各自的返回的地址不同值不同
        string sip_redirecturl = "http://localhost:8222/TaoBaoAPITest/OnSaleList.aspx";
        switch (sip_status)
        {
            case "1004":
            case "1005":
                //divMeg.InnerText = content;
                Response.Redirect(url.InnerText + "&sip_redirecturl=" + sip_redirecturl);

                break;
            case "1001":
            case "9999":
                XmlNodeList mylist = xmlDoc.SelectNodes("rsp/item");
                AddXmlNodesToTable(mylist);
                this.GridView1.DataSource = dt;
                this.GridView1.DataBind();
                break;
            default:
                divMeg.InnerText = content;
                break;
        }


    }


    private void CreatTable()
    {
        dt = new DataTable("ITEM");

        dt.Columns.Add("iid", typeof(string));
        dt.Columns.Add("title", typeof(string));

        dt.Columns.Add("delist_time", typeof(DateTime));
        dt.Columns.Add("nick", typeof(string));

        dt.Columns.Add("pic_path", typeof(string));
        dt.Columns.Add("price", typeof(string));

        dt.Columns.Add("type", typeof(string));
        dt.Columns.Add("cid", typeof(string));
        dt.Columns.Add("post_fee", typeof(string));

    }




    private void AddXmlNodesToTable(XmlNodeList nodes)
    {
        DataRow dr = null;

        foreach (XmlNode node in nodes)
        {
            dr = dt.NewRow();
            dr["iid"] = node.SelectSingleNode("iid").InnerText;
            dr["title"] = node.SelectSingleNode("title").InnerText;

            dr["delist_time"] = node.SelectSingleNode("delist_time").InnerText;
            dr["nick"] = node.SelectSingleNode("nick").InnerText;

            dr["pic_path"] = node.SelectSingleNode("pic_path").InnerText;


            dr["price"] = node.SelectSingleNode("price").InnerText;
            dr["type"] = node.SelectSingleNode("type").InnerText;
            dr["cid"] = node.SelectSingleNode("cid").InnerText;
            //dr["post_fee"] = "";
            dt.Rows.Add(dr);

        }
    }
}
